import { Actions, MixType, ActionCreatorResult } from './types'
/**
 * Build an action creator
 */
export declare function createAction<
  TypeName extends string,
  Action extends (...args: any[]) => any,
>(
  type: TypeName,
  action: Action,
): {
  (...args: unknown[]): ActionCreatorResult<TypeName, ReturnType<Action>>
  type: TypeName
  toString(): TypeName
}
declare type UnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends (
  k: infer I,
) => void
  ? I
  : never
/**
 * A helper to create actions
 */
export declare function createActions<
  Prefix extends string,
  M extends string[] | Record<string, any>,
>(prefix: Prefix, mixin: M): Actions<Prefix, MixType<M>>
export declare function createActions<
  Prefix extends string,
  Ms extends Array<string[] | Record<string, any>>,
>(prefix: Prefix, ...mixins: Ms): Actions<Prefix, UnionToIntersection<MixType<Ms[number]>>>
/**
 * Just a helper to create identity actions
 * createActions('prefix/', {update:identity, save:identity})
 */
export declare const identity: <T>(arg?: T) => T
export {}
